import javax.servlet.*;
import javax.servlet.http.*;

import xmlclx.*;

public class XMLServerServlet extends HttpServlet
{
	static private boolean loaded = false;

	public void init(ServletConfig config) throws ServletException 
	{
		super.init(config);
		if (!loaded)
		{
			ServletContext context = config.getServletContext();
			String path = context.getRealPath("/");
			if (System.getProperty("os.name").startsWith("Windows")) 
				System.load(path+"/XMLCLX.dll");
			else
				System.load(path+"/XMLCLX.so");
			loaded = true;
		}
		// XMLMODULE INSERTION POINT. DO NOT REMOVE THIS COMMENT !
	}

	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, java.io.IOException
	{
		XMLApplication.dispatchRequest(request, response);
	}

	public void destroy()
	{
		XMLApplication.release();
	}
}
