package xmlclx;

import java.io.StringReader;
import java.io.StringWriter;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

public class JavaXSLProc
{
    
    StreamSource styleSheet;
    Transformer serializer;
    
    public JavaXSLProc()
    {
        serializer = null;
        styleSheet = null;
    }
  	public void load(String fileName) throws Exception
  	{
  	    styleSheet = new StreamSource(fileName);
  	}
  	public void loadXML(String xml)
  	{
  	    styleSheet = new StreamSource(new StringReader(xml));
  	}
    public String process(JavaXMLCursor document) throws Exception
    {
        
        StringWriter result = new StringWriter();
        if (serializer == null)
        {
            serializer = TransformerFactory.newInstance().newTransformer(styleSheet);
            serializer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
        //	serializer.setOutputProperty(OutputKeys.INDENT, "yes");
        }
        serializer.transform(new DOMSource(document.xmlDocument), new StreamResult(result));
        return result.toString();
    }
}
