package xmlclx;

public class WrapperFactory
{
	// XMLComponent
	public static XMLComponent.AfterInstructionEventArgs createAfterInstructionEventArgs(int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput)
	{
		XMLComponent.AfterInstructionEventArgs eventArgs = new XMLComponent.AfterInstructionEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		eventArgs.input = new XMLCursor(nativeInput);
		eventArgs.output = new XMLCursor(nativeOutput);
		return eventArgs;
	}
	public static Object[] createAfterInstructionInvokeArgs(int nativeXMLInstruction, int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput)
	{
		Object[] args = new Object[2];
		args[0] = new XMLInstruction(nativeXMLInstruction);
		args[1] = createAfterInstructionEventArgs(nativeInputDoc, nativeOutputDoc, nativeInput, nativeOutput);
		return args;
	}
	public static XMLComponent.AfterInternalInstructionEventArgs createAfterInternalInstructionEventArgs(int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput)
	{
		XMLComponent.AfterInternalInstructionEventArgs eventArgs = new XMLComponent.AfterInternalInstructionEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		eventArgs.input = new XMLCursor(nativeInput);
		eventArgs.output = new XMLCursor(nativeOutput);
		return eventArgs;
	}
	public static Object[] createAfterInternalInstructionInvokeArgs(int nativeXMLInstruction, int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput)
	{
		Object[] args = new Object[2];
		args[0] = new XMLInstruction(nativeXMLInstruction);
		args[1] = createAfterInternalInstructionEventArgs(nativeInputDoc, nativeOutputDoc, nativeInput, nativeOutput);
		return args;
	}
	public static XMLComponent.AfterPreXSLEventArgs createAfterPreXSLEventArgs(int nativeInputDoc, int nativeOutputDoc)
	{
		XMLComponent.AfterPreXSLEventArgs eventArgs = new XMLComponent.AfterPreXSLEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		return eventArgs;
	}
	public static Object[] createAfterPreXSLInvokeArgs(int nativeXMLService, int nativeInputDoc, int nativeOutputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createAfterPreXSLEventArgs(nativeInputDoc, nativeOutputDoc);
		return args;
	}
	public static XMLComponent.AfterXMLGramEventArgs createAfterXMLGramEventArgs(int nativeInputDoc, int nativeOutputDoc)
	{
		XMLComponent.AfterXMLGramEventArgs eventArgs = new XMLComponent.AfterXMLGramEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		return eventArgs;
	}
	public static Object[] createAfterXMLGramInvokeArgs(int nativeXMLGram, int nativeInputDoc, int nativeOutputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLGram(nativeXMLGram);
		args[1] = createAfterXMLGramEventArgs(nativeInputDoc, nativeOutputDoc);
		return args;
	}
	public static XMLComponent.AfterXMLServiceEventArgs createAfterXMLServiceEventArgs()
	{
		XMLComponent.AfterXMLServiceEventArgs eventArgs = new XMLComponent.AfterXMLServiceEventArgs();
		return eventArgs;
	}
	public static Object[] createAfterXMLServiceInvokeArgs(int nativeXMLService)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createAfterXMLServiceEventArgs();
		return args;
	}
	public static XMLComponent.AfterXSLEventArgs createAfterXSLEventArgs(String html)
	{
		XMLComponent.AfterXSLEventArgs eventArgs = new XMLComponent.AfterXSLEventArgs();
		eventArgs.html = html;
		return eventArgs;
	}
	public static Object[] createAfterXSLInvokeArgs(int nativeXMLService, String html)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createAfterXSLEventArgs(html);
		return args;
	}
	public static XMLComponent.BeforeInstructionEventArgs createBeforeInstructionEventArgs(int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput, boolean skip)
	{
		XMLComponent.BeforeInstructionEventArgs eventArgs = new XMLComponent.BeforeInstructionEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		eventArgs.input = new XMLCursor(nativeInput);
		eventArgs.output = new XMLCursor(nativeOutput);
		eventArgs.skip = skip;
		return eventArgs;
	}
	public static Object[] createBeforeInstructionInvokeArgs(int nativeXMLInstruction, int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput, boolean skip)
	{
		Object[] args = new Object[2];
		args[0] = new XMLInstruction(nativeXMLInstruction);
		args[1] = createBeforeInstructionEventArgs(nativeInputDoc, nativeOutputDoc, nativeInput, nativeOutput, skip);
		return args;
	}
	public static XMLComponent.BeforeInternalInstructionEventArgs createBeforeInternalInstructionEventArgs(int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput, boolean skip)
	{
		XMLComponent.BeforeInternalInstructionEventArgs eventArgs = new XMLComponent.BeforeInternalInstructionEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		eventArgs.input = new XMLCursor(nativeInput);
		eventArgs.output = new XMLCursor(nativeOutput);
		eventArgs.skip = skip;
		return eventArgs;
	}
	public static Object[] createBeforeInternalInstructionInvokeArgs(int nativeXMLInstruction, int nativeInputDoc, int nativeOutputDoc, int nativeInput, int nativeOutput, boolean skip)
	{
		Object[] args = new Object[2];
		args[0] = new XMLInstruction(nativeXMLInstruction);
		args[1] = createBeforeInternalInstructionEventArgs(nativeInputDoc, nativeOutputDoc, nativeInput, nativeOutput, skip);
		return args;
	}
	public static XMLComponent.BeforePreXSLEventArgs createBeforePreXSLEventArgs(int nativeInputDoc)
	{
		XMLComponent.BeforePreXSLEventArgs eventArgs = new XMLComponent.BeforePreXSLEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		return eventArgs;
	}
	public static Object[] createBeforePreXSLInvokeArgs(int nativeXMLService, int nativeInputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createBeforePreXSLEventArgs(nativeInputDoc);
		return args;
	}
	public static XMLComponent.BeforeXMLGramEventArgs createBeforeXMLGramEventArgs(int nativeInputDoc, int nativeOutputDoc, boolean skip)
	{
		XMLComponent.BeforeXMLGramEventArgs eventArgs = new XMLComponent.BeforeXMLGramEventArgs();
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.skip = skip;  		
		return eventArgs;
	}
	public static Object[] createBeforeXMLGramInvokeArgs(int nativeXMLGram, int nativeInputDoc, int nativeOutputDoc, boolean skip)
	{
		Object[] args = new Object[2];
		args[0] = new XMLGram(nativeXMLGram);
		args[1] = createBeforeXMLGramEventArgs(nativeInputDoc, nativeOutputDoc, skip);
		return args; 
	}
	public static XMLComponent.BeforeXMLServiceEventArgs createBeforeXMLServiceEventArgs(boolean handled)
	{
		XMLComponent.BeforeXMLServiceEventArgs eventArgs = new XMLComponent.BeforeXMLServiceEventArgs();
		eventArgs.handled = handled;  		
		return eventArgs;
	}
	public static Object[] createBeforeXMLServiceInvokeArgs(int nativeXMLService, boolean handled)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createBeforeXMLServiceEventArgs(handled);
		return args; 
	}
	public static XMLComponent.BeforeXSLEventArgs createBeforeXSLEventArgs(int nativeOutputDoc)
	{
		XMLComponent.BeforeXSLEventArgs eventArgs = new XMLComponent.BeforeXSLEventArgs();
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);  		
		return eventArgs;
	}
	public static Object[] createBeforeXSLInvokeArgs(int nativeXMLService, int nativeOutputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createBeforeXSLEventArgs(nativeOutputDoc);
		return args; 
	}
	public static XMLComponent.AbortEventArgs createAbortEventArgs(int nativeInputDoc, int nativeOutputDoc)
	{
		XMLComponent.AbortEventArgs eventArgs = new XMLComponent.AbortEventArgs();
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);  		
		return eventArgs;
	}
	public static Object[] createAbortInvokeArgs(int nativeXMLGram, int nativeInputDoc, int nativeOutputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLGram);
		args[1] = createAbortEventArgs(nativeInputDoc, nativeOutputDoc);
		return args; 
	}
	public static XMLComponent.CompensateEventArgs createCompensateEventArgs(int nativeInputDoc, int nativeOutputDoc)
	{
		XMLComponent.CompensateEventArgs eventArgs = new XMLComponent.CompensateEventArgs();
		eventArgs.inputDoc = new XMLCursor(nativeInputDoc);
		eventArgs.outputDoc = new XMLCursor(nativeOutputDoc);  		
		return eventArgs;
	}
	public static Object[] createCompensateInvokeArgs(int nativeXMLGram, int nativeInputDoc, int nativeOutputDoc)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLGram);
		args[1] = createCompensateEventArgs(nativeInputDoc, nativeOutputDoc);
		return args; 
	}
	public static XMLComponent.ExceptionEventArgs createExceptionEventArgs(String exceptionClass, String exceptionMessage, boolean handled)
	{
		XMLComponent.ExceptionEventArgs eventArgs = new XMLComponent.ExceptionEventArgs();
		eventArgs.exceptionClass = exceptionClass;
		eventArgs.exceptionMessage = exceptionMessage;
		eventArgs.handled = handled;  		
		return eventArgs;
	}
	public static Object[] createExceptionInvokeArgs(int nativeXMLService, String exceptionClass, String exceptionMessage, boolean handled)
	{
		Object[] args = new Object[2];
		args[0] = new XMLService(nativeXMLService);
		args[1] = createExceptionEventArgs(exceptionClass, exceptionMessage, handled);
		return args; 
	}

	// XMLApplicationEvents
	
	
	public static XMLApplicationEvents.AfterDispatchEventArgs createAfterDispatchEventArgs()
	{
		XMLApplicationEvents.AfterDispatchEventArgs eventArgs = new XMLApplicationEvents.AfterDispatchEventArgs();
		return eventArgs;
	}
	public static Object[] createXMLApplicationAfterDispatchInvokeArgs(int nativeXMLApplication)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createAfterDispatchEventArgs();
		return args; 
	}
	public static XMLApplicationEvents.BeforeDispatchEventArgs createXMLApplicationBeforeDispatchEventArgs(boolean handled)
	{
		XMLApplicationEvents.BeforeDispatchEventArgs eventArgs = new XMLApplicationEvents.BeforeDispatchEventArgs();
		eventArgs.handled = handled;
		return eventArgs;
	}
	public static Object[] createXMLApplicationBeforeDispatchInvokeArgs(int nativeXMLApplication, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createXMLApplicationBeforeDispatchEventArgs(handled);
		return args; 
	}
	public static XMLApplicationEvents.ActionNotFoundEventArgs createActionNotFoundEventArgs(String action, String newAction, boolean handled)
	{
	    XMLApplicationEvents.ActionNotFoundEventArgs eventArgs = new XMLApplicationEvents.ActionNotFoundEventArgs();
	    eventArgs.action = action;
		eventArgs.newAction = newAction;
		eventArgs.handled = handled;
		return eventArgs;
	}
	public static Object[] createActionNotFoundInvokeArgs(int nativeXMLApplication, String action, String newAction, boolean handled)
	{
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createActionNotFoundEventArgs(action, newAction, handled);
		return args; 
	}
	public static XMLApplicationEvents.CreateEventArgs createCreateEventArgs()
	{
		XMLApplicationEvents.CreateEventArgs eventArgs = new XMLApplicationEvents.CreateEventArgs();
		return eventArgs;
	}
	public static Object[] createCreateInvokeArgs(int nativeXMLApplication)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createCreateEventArgs();
		return args; 
	}
	public static XMLApplicationEvents.DestroyEventArgs createDestroyEventArgs()
	{
		XMLApplicationEvents.DestroyEventArgs eventArgs = new XMLApplicationEvents.DestroyEventArgs();
		return eventArgs;
	}
	public static Object[] createDestroyInvokeArgs(int nativeXMLApplication)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createDestroyEventArgs();
		return args; 
	}
	public static XMLApplicationEvents.EnqueueAsyncRequestEventArgs createEnqueueAsyncRequestEventArgs(boolean skip)
	{
		XMLApplicationEvents.EnqueueAsyncRequestEventArgs eventArgs = new XMLApplicationEvents.EnqueueAsyncRequestEventArgs();
		eventArgs.skip = skip;
		return eventArgs;
	}
	public static Object[] createEnqueueAsyncRequestInvokeArgs(int nativeXMLApplication, boolean skip)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createEnqueueAsyncRequestEventArgs(skip);
		return args; 
	}
	public static XMLApplicationEvents.ExceptionEventArgs createXMLApplicationExceptionEventArgs(String message, boolean handled)
	{
		XMLApplicationEvents.ExceptionEventArgs eventArgs = new XMLApplicationEvents.ExceptionEventArgs();
		eventArgs.handled = handled;
		eventArgs.message = message;
		return eventArgs;
	}
	public static Object[] createXMLApplicationExceptionInvokeArgs(int nativeXMLApplication, String message, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createXMLApplicationExceptionEventArgs(message, handled);
		return args; 
	}
	public static XMLApplicationEvents.InitializeEventArgs createXMLApplicationInitializeEventArgs()
	{
		XMLApplicationEvents.InitializeEventArgs eventArgs = new XMLApplicationEvents.InitializeEventArgs();
		return eventArgs;
	}
	public static Object[] createXMLApplicationInitializeInvokeArgs(int nativeXMLApplication)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLApplication(nativeXMLApplication);
		args[1] = createXMLApplicationInitializeEventArgs();
		return args; 
	}
	
	// XMLCollectionEvents
	public static XMLCollectionEvents.AfterDispatchEventArgs createXMLCollectionAfterDispatchEventArgs()
	{
		XMLCollectionEvents.AfterDispatchEventArgs eventArgs = new XMLCollectionEvents.AfterDispatchEventArgs();
		return eventArgs;
	}
	public static Object[] createXMLCollectionAfterDispatchInvokeArgs(int nativeXMLCollection)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createXMLCollectionAfterDispatchEventArgs();
		return args; 
	}
	public static XMLCollectionEvents.AuthenticateEventArgs createAuthenticateEventArgs(boolean handled)
	{
		XMLCollectionEvents.AuthenticateEventArgs eventArgs = new XMLCollectionEvents.AuthenticateEventArgs();
		eventArgs.handled = handled;
		return eventArgs;
	}
	public static Object[] createAuthenticateInvokeArgs(int nativeXMLCollection, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createAuthenticateEventArgs(handled);
		return args; 
	}
	public static XMLCollectionEvents.AuthorizeEventArgs createAuthorizeEventArgs(boolean handled)
	{
		XMLCollectionEvents.AuthorizeEventArgs eventArgs = new XMLCollectionEvents.AuthorizeEventArgs();
		eventArgs.handled = handled;
		return eventArgs;
	}
	public static Object[] createAuthorizeInvokeArgs(int nativeXMLCollection, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createAuthorizeEventArgs(handled);
		return args; 
	}
	public static XMLCollectionEvents.BeforeDispatchEventArgs createXMLCollectionBeforeDispatchEventArgs(boolean handled)
	{
		XMLCollectionEvents.BeforeDispatchEventArgs eventArgs = new XMLCollectionEvents.BeforeDispatchEventArgs();
		eventArgs.handled = handled;
		return eventArgs;
	}
	public static Object[] createXMLCollectionBeforeDispatchInvokeArgs(int nativeXMLCollection, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createXMLCollectionBeforeDispatchEventArgs(handled);
		return args; 
	}
	public static XMLCollectionEvents.ByPassEventArgs createByPassEventArgs(boolean byPass)
	{
		XMLCollectionEvents.ByPassEventArgs eventArgs = new XMLCollectionEvents.ByPassEventArgs();
		eventArgs.byPass = byPass;
		return eventArgs;
	}
	public static Object[] createByPassInvokeArgs(int nativeXMLCollection, boolean byPass)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createByPassEventArgs(byPass);
		return args; 
	}
	public static XMLCollectionEvents.ExceptionEventArgs createXMLCollectionExceptionEventArgs(String message, boolean handled)
	{
		XMLCollectionEvents.ExceptionEventArgs eventArgs = new XMLCollectionEvents.ExceptionEventArgs();
		eventArgs.handled = handled;
		eventArgs.message = message;
		return eventArgs;
	}
	public static Object[] createXMLCollectionExceptionInvokeArgs(int nativeXMLCollection, String message, boolean handled)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createXMLCollectionExceptionEventArgs(message, handled);
		return args; 
	}
	public static XMLCollectionEvents.ExecuteXMLServiceEventArgs createExecuteXMLServiceEventArgs(String xmlServiceName, int nativeXMLService, boolean skip)
	{
		XMLCollectionEvents.ExecuteXMLServiceEventArgs eventArgs = new XMLCollectionEvents.ExecuteXMLServiceEventArgs();
		eventArgs.skip = skip;
		eventArgs.xmlServiceName = xmlServiceName;
		eventArgs.xmlService = new XMLService(nativeXMLService);
		return eventArgs;
	}
	public static Object[] createExecuteXMLServiceInvokeArgs(int nativeXMLCollection, String xmlServiceName, int nativeXMLService, boolean skip)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createExecuteXMLServiceEventArgs(xmlServiceName, nativeXMLService, skip);
		return args; 
	}
	public static XMLCollectionEvents.InitializeEventArgs createXMLCollectionInitializeEventArgs()
	{
		XMLCollectionEvents.InitializeEventArgs eventArgs = new XMLCollectionEvents.InitializeEventArgs();
		return eventArgs;
	}
	public static Object[] createXMLCollectionInitializeInvokeArgs(int nativeXMLCollection)
	{	
		Object[] args = new Object[2];
		args[0] = new XMLCollection(nativeXMLCollection);
		args[1] = createXMLCollectionInitializeEventArgs();
		return args; 
	}
}
