package xmlclx;

import java.lang.reflect.*;

public class XMLApplicationEvents
{
	
	public static class AfterDispatchEventArgs
	{
	}
	public static class BeforeDispatchEventArgs
	{
		public boolean handled;
	}
	public static class ActionNotFoundEventArgs
	{
		public String action;
		public boolean handled;
		public String newAction;
	}
	public static class CreateEventArgs
	{
	}
	public static class DestroyEventArgs
	{
	}
	public static class EnqueueAsyncRequestEventArgs
	{
		public boolean skip;
	}
	public static class ExceptionEventArgs
	{
		public boolean handled;
		public String message;
	}
	public static class InitializeEventArgs
	{
	}
	

	/*
 	 * constant types 
 	 */
	
	final private Class[] afterDispatchTypes = {XMLApplication.class, AfterDispatchEventArgs.class};
	final private Class[] beforeDispatchTypes = {XMLApplication.class, BeforeDispatchEventArgs.class};
	final private Class[] actionNotFoundTypes = {XMLApplication.class, ActionNotFoundEventArgs.class};
	final private Class[] createTypes = {XMLApplication.class, CreateEventArgs.class};
	final private Class[] destroyTypes = {XMLApplication.class, DestroyEventArgs.class};
	final private Class[] enqueueAsyncRequestTypes = {XMLApplication.class, EnqueueAsyncRequestEventArgs.class};
	final private Class[] exceptionTypes = {XMLApplication.class, ExceptionEventArgs.class};
	final private Class[] initializeTypes = {XMLApplication.class, InitializeEventArgs.class};

	private Method afterDispatchEventHandler;
	private Method beforeDispatchEventHandler;
	private Method onActionNotFoundEventHandler;
	private Method onCreateEventHandler;
	private Method onDestroyEventHandler;
	private Method onEnqueueAsyncRequestEventHandler;
	private Method onExceptionEventHandler;
	private Method onInitializeEventHandler;
	
	public XMLApplicationEvents()
	{
	}
	public void addAfterDispatch(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterDispatchEventHandler = xmlModule.getClass().getMethod(methodName, afterDispatchTypes);
	}
	public void addBeforeDispatch(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeDispatchEventHandler = xmlModule.getClass().getMethod(methodName, beforeDispatchTypes);
	}
	public void addOnActionNotFound(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onActionNotFoundEventHandler = xmlModule.getClass().getMethod(methodName, actionNotFoundTypes);
	}
	public void addOnCreate(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onCreateEventHandler = xmlModule.getClass().getMethod(methodName, createTypes);
	}
	public void addOnDestroy(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onDestroyEventHandler = xmlModule.getClass().getMethod(methodName, destroyTypes); 
	}
	public void addOnEnqueueAsyncRequest(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onEnqueueAsyncRequestEventHandler = xmlModule.getClass().getMethod(methodName, enqueueAsyncRequestTypes);
	}
	public void addOnException(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onExceptionEventHandler = xmlModule.getClass().getMethod(methodName, exceptionTypes);
	}
	public void addOnInitialize(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		onInitializeEventHandler = xmlModule.getClass().getMethod(methodName, initializeTypes);
	}
}
