package xmlclx;

import java.lang.reflect.*;

public class XMLComponent
{
	/*
	 * EventArgs classes
	 */
	public static class AfterInstructionEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
		public XMLCursor input;
		public XMLCursor output;
	}
	public static class AfterInternalInstructionEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
		public XMLCursor input;
		public XMLCursor output;
	}
	public static class AfterPreXSLEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
	}
	public static class AfterXMLGramEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
	}
	public static class AfterXMLServiceEventArgs
	{
	}
	public static class AfterXSLEventArgs
	{
		public String html;
	}
	public static class BeforeInstructionEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
		public XMLCursor input;
		public XMLCursor output;
		public boolean skip;
	}
	public static class BeforeInternalInstructionEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
		public XMLCursor input;
		public XMLCursor output;
		public boolean skip;
	}
	public static class BeforePreXSLEventArgs
	{
		public XMLCursor inputDoc;
	}	
	public static class BeforeXMLGramEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
		public boolean skip;
	}
	public static class BeforeXMLServiceEventArgs
	{
		public boolean handled;
	}
	public static class BeforeXSLEventArgs
	{
		public XMLCursor outputDoc;
	}
	public static class AbortEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
	}
	public static class CompensateEventArgs
	{
		public XMLCursor inputDoc;
		public XMLCursor outputDoc;
	}
	public static class ExceptionEventArgs
	{
		public String exceptionClass;
		public String exceptionMessage;
		public boolean handled;
	}
	
	/*
	 * constant types 
	 */
	
	final private Class[] afterInstructionTypes = {XMLInstruction.class, AfterInstructionEventArgs.class};
	final private Class[] afterInternalInstructionTypes = {XMLInstruction.class, AfterInternalInstructionEventArgs.class};
	final private Class[] afterPreXSLTypes = {XMLService.class, AfterPreXSLEventArgs.class};
	final private Class[] afterXMLGramTypes = {XMLGram.class, AfterXMLGramEventArgs.class};
	final private Class[] afterXMLServiceTypes = {XMLService.class, AfterXMLServiceEventArgs.class};
	final private Class[] afterXSLTypes = {XMLService.class, AfterXSLEventArgs.class};
	final private Class[] beforeInstructionTypes = {XMLInstruction.class, BeforeInstructionEventArgs.class};
	final private Class[] beforeInternalInstructionTypes = {XMLInstruction.class, BeforeInternalInstructionEventArgs.class};
	final private Class[] beforePreXSLTypes = {XMLService.class, BeforePreXSLEventArgs.class};
	final private Class[] beforeXMLGramTypes = {XMLGram.class, BeforeXMLGramEventArgs.class};
	final private Class[] beforeXMLServiceTypes = {XMLService.class, BeforeXMLServiceEventArgs.class};
	final private Class[] beforeXSLTypes = {XMLService.class, BeforeXSLEventArgs.class};
	final private Class[] abortTypes = {XMLGram.class, AbortEventArgs.class};
	final private Class[] compensateTypes = {XMLGram.class, CompensateEventArgs.class};
	final private Class[] exceptionTypes = {XMLService.class, ExceptionEventArgs.class};
	
	private Method afterInstructionEventHandler;
	private Method afterInternalInstructionEventHandler;
	private Method afterPreXSLEventHandler;
	private Method afterXMLGramEventHandler;
	private Method afterXMLServiceEventHandler;
	private Method afterXSLEventHandler;
	private Method beforeInstructionEventHandler;
	private Method beforeInternalInstructionEventHandler;
	private Method beforePreXSLEventHandler; 
	private Method beforeXMLGramEventHandler;
	private Method beforeXMLServiceEventHandler;
	private Method beforeXSLEventHandler;
	private Method abortEventHandler;
	private Method compensateEventHandler;
	private Method exceptionEventHandler;
	
	public XMLComponent()
	{
		
	}
	public void addAfterInstruction(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterInstructionEventHandler = xmlModule.getClass().getMethod(methodName, afterInstructionTypes);
	}
	public void addAfterInternalInstruction(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterInternalInstructionEventHandler = xmlModule.getClass().getMethod(methodName, afterInternalInstructionTypes);
	}
	public void addAfterPreXSL(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterPreXSLEventHandler = xmlModule.getClass().getMethod(methodName, afterPreXSLTypes);
	}
	public void addAfterXMLGram(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterXMLGramEventHandler = xmlModule.getClass().getMethod(methodName, afterXMLGramTypes);
	}
	public void addAfterXMLService(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterXMLServiceEventHandler = xmlModule.getClass().getMethod(methodName, afterXMLServiceTypes);
	}
	public void addAfterXSL(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		afterXSLEventHandler = xmlModule.getClass().getMethod(methodName, afterXSLTypes);
	}
	public void addBeforeInstruction(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeInstructionEventHandler = xmlModule.getClass().getMethod(methodName, beforeInstructionTypes);
	}
	public void addBeforeInternalInstruction(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeInternalInstructionEventHandler = xmlModule.getClass().getMethod(methodName, beforeInternalInstructionTypes);
	}
	public void addBeforePreXSL(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforePreXSLEventHandler = xmlModule.getClass().getMethod(methodName, beforePreXSLTypes);
	}
	public void addBeforeXMLGram(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeXMLGramEventHandler = xmlModule.getClass().getMethod(methodName, beforeXMLGramTypes);
	}
	public void addBeforeXMLService(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeXMLServiceEventHandler = xmlModule.getClass().getMethod(methodName, beforeXMLServiceTypes);
	}
	public void addBeforeXSL(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		beforeXSLEventHandler = xmlModule.getClass().getMethod(methodName, beforeXSLTypes);
	}
	public void addAbort(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		abortEventHandler = xmlModule.getClass().getMethod(methodName, abortTypes);
	}
	public void addCompensate(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		compensateEventHandler = xmlModule.getClass().getMethod(methodName, compensateTypes);
	}
	public void addException(XMLModule xmlModule, String methodName) throws NoSuchMethodException
	{
		exceptionEventHandler = xmlModule.getClass().getMethod(methodName, exceptionTypes);
	}
}
